{% extends 'base.html.twig' %}

{% block body -%}
    <main class='main-content bgc-grey-100'>
        <div id='mainContent'>
            <h1>Dati eliminabili</h1>

            <div id="syncComp">
                <ul class="nav nav-pills mb-3" role="tablist">
                    <li class="nav-item" role="presentation" v-for="tab in tabs"><a @click.prevent="currentTab = tab.id" role="tab" class="nav-link" :class="{active: currentTab == tab.id}" href="#">${ tab.name }</a></li>
                </ul>

                <div class="tab-content">
                    <template v-for="tab in tabs">
                        <div role="tabpanel" class="tab-pane active" v-if="currentTab == tab.id">
                            <template v-if="data[tab.id] !== undefined">
                                <div class="card" v-if="showDeleteArea">
                                    <div class="card-body">
                                        <template v-if="data[tab.id] !== undefined && Object.keys(data[tab.id]).length > 0">
                                            <synccomp-table :entities="data[tab.id]" :entity-type="tab.id" default-action="trash" :default-delete-options="tab.defaultDeleteOptions"
                                                            delete-url="{{ path('config_provider_remove_data', {'providerId' :  "*providerId*"}) }}"
                                                            url="{{ path('trash_do_trash') }}" :initial-state-label="canDelete ? 'Da eliminare' : 'Da cestinare'"
                                                            :show-main-action="tab.canBeTrashed" main-action-label="Cestina" :show-delete-action="canDelete" :extra-columns="columns"
                                                            ></synccomp-table>
                                        </template>
                                        <div v-else>
                                            Non ci sono dati da visualizzare
                                        </div>
                                    </div>
                                </div>
                            </template>
                            <div v-else>
                                Non ci sono dati da visualizzare
                            </div>
                        </div>
                    </template>
                </div>

            </div>
        </div>
    </main>
{% endblock %}

{% block javascripts -%}
    {{ parent() }}

    <script type="text/javascript">

        window.addEventListener('load', () => {
            VueCreateApp({
                delimiters: ['${', '}'],
                data: () => ({
                    loading: false,
                    data: {{ data|json_encode|raw }},
                    tabs: [
                        {id: "students", name: "Studenti", defaultDeleteOptions: {deleteOnLdap: false, deleteOnGApps: '0', gAppsOu: '/'}, canBeTrashed: true},
                        {id: "groups", name: "Classi", defaultDeleteOptions: {deleteOnLdap: false, deleteOnGApps: '0'}, canBeTrashed: false},
                        {id: "teachers", name: "Docenti", defaultDeleteOptions: {deleteOnLdap: false, deleteOnGApps: '0', gAppsOu: '/'}, canBeTrashed: true},
                        {id: "sectors", name: "Settori", defaultDeleteOptions: {}, canBeTrashed: false},
                        {id: "subjects", name: "Materie", defaultDeleteOptions: {}, canBeTrashed: false}
                    ],
                    executionQueue: [],
                    queueWorking: false,
                    currentTab: 'students',
                    canDelete: {{ canDelete ? "true" : "false" }}
                }),
                computed: {
                    currentTabData() {
                        return this.tabs.find(tab => tab.id === this.currentTab);
                    },
                    showDeleteArea() {
                        return this.canDelete || this.currentTabData.canBeTrashed;
                    },
                    columns() {
                        let columns = [{key: 'providerName', name: 'Provider'}];

                        if(this.currentTab === 'students') {
                            columns.push({key: 'groups', name: 'Gruppi'});
                        }

                        if(this.currentTab === 'students' || this.currentTab === 'teachers') {
                            columns.push({key: 'username', name: 'Username'});
                            columns.push({key: 'email', name: 'Email'});
                            columns.push({key: 'ipadSerials', name: 'Seriali iPad'});
                        }

                        // columns.push({key: 'trashDate', name: 'Data cestinamento'});
                        return columns;
                    }
                },
                methods: {

                },
                components: {
                    'synccomp-table': SyncTable
                },
                mounted: function () {

                }
            }).mount("#syncComp");
        });
    </script>

{% endblock %}